<template>
  <a-modal
    :title="title"
    :width="800"
    :visible="visible"
    :confirmLoading="confirmLoading"
    @ok="handleOk"
    @cancel="handleCancel"
    cancelText="关闭">
    
    <a-spin :spinning="confirmLoading">
      <a-form :form="form">
      
        <a-form-item
          :labelCol="labelCol"
          :wrapperCol="wrapperCol"
          label="模板名称">
          <a-input placeholder="请输入模板名称" v-decorator="['name', validatorRules.name ]" />
        </a-form-item>
        <a-form-item
          :labelCol="labelCol"
          :wrapperCol="wrapperCol"
          label="生成规则">
          <a-input placeholder="请输入生成规则" v-decorator="['rule', validatorRules.rule ]" />
          <br>

          <a-button :size="size" @click="clickQd">渠道</a-button>
          <a-button :size="size" @click="clickSclx">素材类型</a-button>
          <a-button :size="size" @click="clickScmc">素材名称</a-button>
          <a-button :size="size" @click="clickRq">日期</a-button>
        </a-form-item>
        <a-form-item
          :labelCol="labelCol"
          :wrapperCol="wrapperCol"
          label="模板状态信息">
          <a-input-number v-decorator="[ 'status', validatorRules.status ]" />
        </a-form-item>
		
      </a-form>
    </a-spin>
  </a-modal>
</template>

<script>
  import { httpAction } from '@/api/manage'
  import pick from 'lodash.pick'
  import moment from "moment"

  export default {
    name: "BytedanceNameModelRuleModal",
    data () {
      return {
        size: 'large',
        title:"操作",
        visible: false,
        model: {},
        labelCol: {
          xs: { span: 24 },
          sm: { span: 5 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },

        confirmLoading: false,
        form: this.$form.createForm(this),
        validatorRules:{
        name:{rules: [{ required: true, message: '请输入模板名称!' }]},
        rule:{rules: [{ required: true, message: '请输入生成规格!' }]},
        status:{rules: [{ required: true, message: '请输入模板状态信息!' }]},
        },
        url: {
          add: "/ctop/bytedanceNameModelRule/add",
          edit: "/ctop/bytedanceNameModelRule/edit",
        },
      }
    },
    created () {
    },
    methods: {
      clickQd(){
        this.form.setFieldsValue({
          "rule": this.form.getFieldValue("rule") +"{渠道号}"
        });
      },
      clickSclx(){
        this.form.setFieldsValue({
          "rule": this.form.getFieldValue("rule") +"{素材类型}"
        });
      },
      clickScmc(){
        this.form.setFieldsValue({
          "rule": this.form.getFieldValue("rule") +"{素材名称}"
        });
      },
      clickRq(){
        this.form.setFieldsValue({
          "rule": this.form.getFieldValue("rule") +"{日期}"
        });
      },
      add () {
        this.edit({});
      },
      edit (record) {
        this.form.resetFields();
        this.model = Object.assign({}, record);
        this.visible = true;
        this.$nextTick(() => {
          this.form.setFieldsValue(pick(this.model,'name','rule','status'))
		  //时间格式化
        });

      },
      close () {
        this.$emit('close');
        this.visible = false;
      },
      handleOk () {
        const that = this;
        // 触发表单验证
        this.form.validateFields((err, values) => {
          if (!err) {
            that.confirmLoading = true;
            let httpurl = '';
            let method = '';
            if(!this.model.id){
              httpurl+=this.url.add;
              method = 'post';
            }else{
              httpurl+=this.url.edit;
               method = 'put';
            }
            let formData = Object.assign(this.model, values);
            //时间格式化
            
            console.log(formData)
            httpAction(httpurl,formData,method).then((res)=>{
              if(res.success){
                that.$message.success(res.message);
                that.$emit('ok');
              }else{
                that.$message.warning(res.message);
              }
            }).finally(() => {
              that.confirmLoading = false;
              that.close();
            })



          }
        })
      },
      handleCancel () {
        this.close()
      },


    }
  }
</script>

<style lang="less" scoped>

</style>